package SpaceTime.DataModel;


/**
* SpaceTime/DataModel/SpaceTimeNodeOperations.java .
* Generated by the IDL-to-Java compiler (portable), version "3.2"
* from SpaceTime/DataModel/SpaceTimeNode.idl
* Thursday, April 26, 2007 1:20:06 AM EDT
*/


/**
	SpaceTimeNode is the primary data structure for storing space-time data.
	Nodes all have an identifier name, and an optional set of properties
	and edge properties.
	Passed by reference
	*/
public interface SpaceTimeNodeOperations 
{

  /// Returns node name
  String ToString () throws Ch.Elca.Iiop.GenericUserException;

  ///
  void NotifyChange () throws Ch.Elca.Iiop.GenericUserException;

  /// Returns the data adapter that created this node
  SpaceTime.DataModel.SpaceTimeDataAdapter GetAdapter () throws Ch.Elca.Iiop.GenericUserException;

  /// Inserts a child into the node tree.
  void AddChild (SpaceTime.DataModel.SpaceTimeNode child) throws Ch.Elca.Iiop.GenericUserException;

  /// Inserts a child at the specified index.
  void AddChildAt (SpaceTime.DataModel.SpaceTimeNode child, int index) throws Ch.Elca.Iiop.GenericUserException;

  /// Searches entire tree for node with name childName.
  SpaceTime.DataModel.SpaceTimeNode FindChild (String childName) throws Ch.Elca.Iiop.GenericUserException;

  /// Gets total number of children
  int GetChildrenCount () throws Ch.Elca.Iiop.GenericUserException;

  /// Gets the display name of the node
  String GetDisplayName () throws Ch.Elca.Iiop.GenericUserException;

  /// Gets the highest node in the ancestors tree
  SpaceTime.DataModel.SpaceTimeNode GetRootParent () throws Ch.Elca.Iiop.GenericUserException;

  /// Gets child at specified index
  SpaceTime.DataModel.SpaceTimeNode GetChild (int index) throws Ch.Elca.Iiop.GenericUserException;

  /// Returns a list of unassociated property names
  SpaceTime.DataModel.DMArrayList GetUnassociatedPropertyNames () throws Ch.Elca.Iiop.GenericUserException;

  /// Gets all property names within this node
  SpaceTime.DataModel.DMArrayList GetPropertyNames () throws Ch.Elca.Iiop.GenericUserException;

  /// Number of edges
  int GetEdgeCount () throws Ch.Elca.Iiop.GenericUserException;

  /// Gets the non-inherited property count
  int GetLocalPropertyCount () throws Ch.Elca.Iiop.GenericUserException;

  /// Gets the non-inherited property at index.
  SpaceTime.DataModel.SpaceTimeProperty GetLocalProperty (int index) throws Ch.Elca.Iiop.GenericUserException;

  ///  Gets property by name.
  SpaceTime.DataModel.SpaceTimeProperty GetProperty (String name) throws Ch.Elca.Iiop.GenericUserException;

  /// Checks if there is a node with specified name in the ancestors tree
  boolean IsA (String name) throws Ch.Elca.Iiop.GenericUserException;

  /// Resets all properties defined by default rules
  void ResetDefaultProperties () throws Ch.Elca.Iiop.GenericUserException;

  /// Apply default rules to the node
  void ApplyDefaultRules () throws Ch.Elca.Iiop.GenericUserException;

  /// Returns edge at specified index
  SpaceTime.DataModel.SpaceTimeEdge GetEdgeAt (int index) throws Ch.Elca.Iiop.GenericUserException;

  /// Find edge by type
  SpaceTime.DataModel.SpaceTimeEdge GetEdge (String edgeType) throws Ch.Elca.Iiop.GenericUserException;

  /// Helper to fetch an edge property value propertyType
  SpaceTime.DataModel.SpaceTimeProperty GetEdgeProperty (String edgeType, String propertyType) throws Ch.Elca.Iiop.GenericUserException;

  /// Adds a new property to this node.
  void AddProperty (SpaceTime.DataModel.SpaceTimeProperty property) throws Ch.Elca.Iiop.GenericUserException;

  /// Adds an edge property to the specified edgeType
  void AddEdgeProperty (String edgeType, SpaceTime.DataModel.SpaceTimeProperty edgeProperty) throws Ch.Elca.Iiop.GenericUserException;

  /// Adds a new non-isA edge to this node.
  void AddEdge (SpaceTime.DataModel.SpaceTimeEdge edge) throws Ch.Elca.Iiop.GenericUserException;

  /// Removes an edge by type
  void RemoveEdge (String edgeType) throws Ch.Elca.Iiop.GenericUserException;

  /// Flush scores of the node and all its children
  void FlushAllScores () throws Ch.Elca.Iiop.GenericUserException;

  /// Clears all properties and edges associated with this node and removes it from parent.
  void Release () throws Ch.Elca.Iiop.GenericUserException;

  /// Returns the index of this node within the parent's child collection
  int GetParentIndex () throws Ch.Elca.Iiop.GenericUserException;

  //@ADD
  int TimeSlotsCount () throws Ch.Elca.Iiop.GenericUserException;

  //@ADD
  SpaceTime.DataModel.TimeSlot TimeSlotAt (int index) throws Ch.Elca.Iiop.GenericUserException;

  /// Active flag
  boolean Active ();

  /// Active flag
  void Active (boolean newActive);

  /// Default rules permission flag
  boolean DefaultRulesAllowed ();

  /// Default rules permission flag
  void DefaultRulesAllowed (boolean newDefaultRulesAllowed);

  /// Node's score
  double Score ();

  /// Node's score
  void Score (double newScore);

  /**
  		* Optional attribute, can have 3 values:
  		* "true" 
  		* "false" 
  		* "default" 
  		* Only room nodes can have this property (this is a semantic restriction and not a restriction enforced by the DTD/XSD)
  		*/
  String ShownInGUI ();

  /**
  		* Optional attribute, can have 3 values:
  		* "true" 
  		* "false" 
  		* "default" 
  		* Only room nodes can have this property (this is a semantic restriction and not a restriction enforced by the DTD/XSD)
  		*/
  void ShownInGUI (String newShownInGUI);

  /// Name
  String Name ();

  /// Parent node
  SpaceTime.DataModel.SpaceTimeNode Parent ();

  /// Parent isA edge
  SpaceTime.DataModel.SpaceTimeEdge ParentEdge ();

  /// Parent isA edge
  void ParentEdge (SpaceTime.DataModel.SpaceTimeEdge newParentEdge);
} // interface SpaceTimeNodeOperations
